
world/mob = /mob/create_character	// when the player logs in, he should go to the character
								 	// creation screen.

// A list of races and gender icons for each.
var/list/races = list(
	list('badger_male.dmi','badger_female.dmi'),
	list('fox_male.dmi','fox_female.dmi'),
	list('hedgehog_male.dmi','hedgehog_female.dmi'),
	list('mouse_male.dmi','mouse_female.dmi'),
	list('rabbit_male.dmi','rabbit_female.dmi'),
	list('rat_male.dmi','rat_female.dmi'),
	list('shrew_male.dmi','shrew_female.dmi'),
	list('squirrel_male.dmi','squirrel_female.dmi') )

mob/create_character
	invisibility = 101
	var/cg_icon/demo/_characterCreation	// pointer to the cg_icon
	var/obj/preview						// HUD object for displaying the current cg_icon
	var/list/race_select = 1			// which race is selected
	var/gender_select = 1				// which gender is selected
	Login()
		loc = locate(6,6,1)
		_characterCreation = new()
		client.eye = locate(6,6,1)
		preview = new
		preview.name = "Preview"
		preview.screen_loc = "6,6"

		SetSourceIcon()
		return ..()

	proc/SetSourceIcon()
		// set the source icon based on the gender and race icons.
		var/list/l = races[race_select]
		_characterCreation.SetSource(l[gender_select])
		UpdatePreview()

	// basic procedures for altering the cg_icons
	proc/ScrollRace(Dir)
		race_select += Dir
		if(race_select > races.len) race_select = 1
		if(race_select < 1) race_select = races.len

		SetSourceIcon()
	proc/ScrollGender(Dir)
		gender_select += Dir
		if(gender_select > 2) gender_select = 1
		if(gender_select < 1) gender_select = 2

		SetSourceIcon()
	proc/UpdatePreview()
		client.screen -= preview
		preview.icon = _characterCreation.Render()
		client.screen += preview

	proc/ScrollHead(Dir)
		_characterCreation.torso.head.scroller.Scroll(Dir)
		UpdatePreview()
	proc/ScrollTorso(Dir)
		_characterCreation.torso.scroller.Scroll(Dir)
		UpdatePreview()
	proc/ScrollLegs(Dir)
		_characterCreation.legs.scroller.Scroll(Dir)
		UpdatePreview()
	proc/ScrollHeight(Dir)
		_characterCreation.torso.height.Scroll(Dir)
		UpdatePreview()
	proc/ScrollNeck(Dir)
		_characterCreation.torso.head.neck.Scroll(Dir)
		UpdatePreview()
	proc/ScrollEyes(Dir)
		_characterCreation.torso.head.eyes.Scroll(Dir)
		UpdatePreview()
	proc/ScrollFlip(Dir)
		_characterCreation.flip.Scroll(Dir)
		UpdatePreview()
	proc/Done()
		// the player is finished creating his icon, send him to the main map.
		client.screen -= preview
		var/mob/mob = new (locate(2,2,2))
		mob.icon = _characterCreation.Render()
		mob.name = client.key
		client.eye = mob
		client.mob = mob



cg_icon/demo
	source= 'badger_male.dmi' // Defualt icon
	var
		cg_icon/torso/torso
		cg_icon/legs/legs
		cg_effect/scroller/icon_flip/flip
	Initialize()
		legs = new(src)
		torso = new(src)
		flip = new (src)
cg_icon
	proc/SetSource(i)
		source = i
		// sets the source icon for all of the children as well
		for(var/cg_icon/c in children)
			c.SetSource(i)
		for(var/cg_effect/e in effects)
			e.Initialize()

cg_icon/head
	var/cg_effect/scroller/state_scroller/scroller
	var/cg_effect/scroller/pixel_offset/neck
	var/cg_effect/scroller/eye_color_swap/eyes
	Initialize()
		source = parent.source
		scroller = new /cg_effect/scroller/state_scroller/head (src)
		eyes = new /cg_effect/scroller/eye_color_swap (src)
		neck = new /cg_effect/scroller/pixel_offset/neck (src)

cg_icon/torso
	var/cg_effect/scroller/state_scroller/scroller
	var/cg_effect/scroller/pixel_offset/height
	var/cg_icon/head/head
	Initialize()
		source = parent.source
		head = new(src)
		scroller = new /cg_effect/scroller/state_scroller/torso (src)
		height = new /cg_effect/scroller/pixel_offset/height (src)

cg_icon/legs
	var/cg_effect/scroller/state_scroller/scroller
	Initialize()
		source = parent.source
		scroller = new /cg_effect/scroller/state_scroller/legs (src)

/*
scroller cg_effect
This effect is the base for effects that can be manipulated by scrolling.
*/
cg_effect/scroller
	var
		list/values
		value

	proc/SelectValue(i)
		if(i < 1 || i > values.len) i = 1
		value = values[i]
	proc/Scroll(Dir)
		var/i = values.Find(value) + Dir
		if(i > values.len) i = 1
		if(i < 1) i = values.len
		SelectValue(i)

	eye_color_swap
		Render(icon/i)
			var/list/color = value
			i.SwapColor(rgb(255,0,204),color[1])
			i.SwapColor(rgb(204,0,204),color[2])
			return i
		Initialize()
			values = list (rgb(0,0,204),rgb(0,204,0),rgb(0,0,0),rgb(204,204,204))
			values = list (
					list(rgb(0,0,204), rgb(0,0,153)),
					list(rgb(0,204,0), rgb(0,153,0)),
					list(rgb(0,0,0), rgb(204,204,204)),
					list(rgb(204,204,204), rgb(204,204,204)) )
			SelectValue(1)
	icon_flip
		Render(icon/i)
			if(value)
				i.Flip(EAST)
			return i
		Initialize()
			values = list(FALSE, TRUE)
			SelectValue(1)

	pixel_offset
		Render(icon/i)
			i.Shift(NORTH,value)
			return i
		height
			Initialize()
				values = list (0,1,2,-1)
				SelectValue(1)
		neck
			Initialize()
				values = list (0,1,-1)
				SelectValue(1)

	/*
		state_scroller cg_effect
		This effect is used to scroll through a list of icon states.
	*/


	state_scroller
		_renderFirst = TRUE	// state scrollers should be rendered before children
		Render(icon/i)
			i = icon(parent.source, value)
			return i

		// Head, Torso, and Leg selectors
		head
			// Initialize the values for head
			Initialize()
				values = list()
				for(var/state in icon_states(parent.source))
					if(findtext(state, "head"))
						values += state
				SelectValue(1)
				return values.len
		torso
			// Initialize the values for torso
			Initialize()
				values = list()
				for(var/state in icon_states(parent.source))
					if(findtext(state, "torso")) values += state
				SelectValue(1)
				return values.len
		legs
			// Initialize the values for head
			Initialize()
				values = list()
				for(var/state in icon_states(parent.source))
					if(findtext(state, "legs")) values += state
				SelectValue(1)
				return values.len

/*
 You can implement the interface however you like.
 This demo shows one way to do it on the game screen.
*/

obj/demo_interface
	icon = 'demo_interface.dmi'
	HeadScrollLeft
		icon_state = "arrow_left_1"
		Click()
			if(istype(usr,/mob/create_character)) usr:ScrollHead(-1)
	HeadScrollRight
		icon_state = "arrow_right_1"
		Click()
			if(istype(usr,/mob/create_character)) usr:ScrollHead(1)
	TorsoScrollLeft
		icon_state = "arrow_left_2"
		Click()
			if(istype(usr,/mob/create_character)) usr:ScrollTorso(-1)
	TorsoScrollRight
		icon_state = "arrow_right_2"
		Click()
			if(istype(usr,/mob/create_character)) usr:ScrollTorso(1)
	LegsScrollLeft
		icon_state = "arrow_left_3"
		Click()
			if(istype(usr,/mob/create_character)) usr:ScrollLegs(-1)
	LegsScrollRight
		icon_state = "arrow_right_3"
		Click()
			if(istype(usr,/mob/create_character)) usr:ScrollLegs(1)
	HeightScrollLeft
		icon_state = "arrow_left_4"
		Click()
			if(istype(usr,/mob/create_character)) usr:ScrollHeight(-1)
	HeightScrollRight
		icon_state = "arrow_right_4"
		Click()
			if(istype(usr,/mob/create_character)) usr:ScrollHeight(1)
	NeckScrollLeft
		icon_state = "arrow_left_5"
		Click()
			if(istype(usr,/mob/create_character)) usr:ScrollNeck(-1)
	NeckScrollRight
		icon_state = "arrow_right_5"
		Click()
			if(istype(usr,/mob/create_character)) usr:ScrollNeck(1)
	EyesScrollLeft
		icon_state = "arrow_left_1"
		Click()
			if(istype(usr,/mob/create_character)) usr:ScrollEyes(-1)
	EyesScrollRight
		icon_state = "arrow_right_1"
		Click()
			if(istype(usr,/mob/create_character)) usr:ScrollEyes(1)
	FlipScrollLeft
		icon_state = "arrow_left_2"
		Click()
			if(istype(usr,/mob/create_character)) usr:ScrollFlip(-1)
	FlipScrollRight
		icon_state = "arrow_right_2"
		Click()
			if(istype(usr,/mob/create_character)) usr:ScrollFlip(1)
	RaceScrollLeft
		icon_state = "arrow_left_3"
		Click()
			if(istype(usr,/mob/create_character)) usr:ScrollRace(-1)
	RaceScrollRight
		icon_state = "arrow_right_3"
		Click()
			if(istype(usr,/mob/create_character)) usr:ScrollRace(1)
	GenderScrollLeft
		icon_state = "arrow_left_4"
		Click()
			if(istype(usr,/mob/create_character)) usr:ScrollGender(-1)
	GenderScrollRight
		icon_state = "arrow_right_4"
		Click()
			if(istype(usr,/mob/create_character)) usr:ScrollGender(1)
	Done
		icon_state = "done"
		Click()
			if(istype(usr,/mob/create_character)) usr:Done()

turf/text
	icon = 'demo_interface.dmi'
	icon_state = "text"
turf/text2
	icon = 'demo_interface.dmi'
	icon_state = "text2"
turf/box
	icon = 'demo_interface.dmi'
	icon_state = "box"

turf/grass
	icon = 'demo_turfs.dmi'
	icon_state = "grass"
turf/dirt
	icon = 'demo_turfs.dmi'
	icon_state = "dirt"
turf/tree
	icon = 'demo_turfs.dmi'
	icon_state = "tree"
	density = 1
